/*******************************************************************************
 * Copyright (c) 2014 Bosch Software Innovations GmbH and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v1.0 which accompany this distribution.
 *
 * The Eclipse Public License is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * The Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 * Bosch Software Innovations GmbH - Please refer to git log
 *
 *******************************************************************************/
/*
 * generated by Xtext
 */
grammar InternalMapping;

options {
	superClass=AbstractInternalAntlrParser;
}

@lexer::header {
package org.eclipse.vorto.editor.mapping.parser.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.parser.antlr.Lexer;
}

@parser::header {
package org.eclipse.vorto.editor.mapping.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.vorto.editor.mapping.services.MappingGrammarAccess;

}

@parser::members {

 	private MappingGrammarAccess grammarAccess;

    public InternalMappingParser(TokenStream input, MappingGrammarAccess grammarAccess) {
        this(input);
        this.grammarAccess = grammarAccess;
        registerRules(grammarAccess.getGrammar());
    }

    @Override
    protected String getFirstRuleName() {
    	return "MappingModel";
   	}

   	@Override
   	protected MappingGrammarAccess getGrammarAccess() {
   		return grammarAccess;
   	}

}

@rulecatch {
    catch (RecognitionException re) {
        recover(input,re);
        appendSkippedTokens();
    }
}

// Entry rule entryRuleMappingModel
entryRuleMappingModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getMappingModelRule()); }
	iv_ruleMappingModel=ruleMappingModel
	{ $current=$iv_ruleMappingModel.current; }
	EOF;

// Rule MappingModel
ruleMappingModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getMappingModelAccess().getInfoModelMappingModelParserRuleCall_0());
		}
		this_InfoModelMappingModel_0=ruleInfoModelMappingModel
		{
			$current = $this_InfoModelMappingModel_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getMappingModelAccess().getFunctionBlockMappingModelParserRuleCall_1());
		}
		this_FunctionBlockMappingModel_1=ruleFunctionBlockMappingModel
		{
			$current = $this_FunctionBlockMappingModel_1.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getMappingModelAccess().getDataTypeMappingModelParserRuleCall_2());
		}
		this_DataTypeMappingModel_2=ruleDataTypeMappingModel
		{
			$current = $this_DataTypeMappingModel_2.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleDataTypeMappingModel
entryRuleDataTypeMappingModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getDataTypeMappingModelRule()); }
	iv_ruleDataTypeMappingModel=ruleDataTypeMappingModel
	{ $current=$iv_ruleDataTypeMappingModel.current; }
	EOF;

// Rule DataTypeMappingModel
ruleDataTypeMappingModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getDataTypeMappingModelAccess().getEntityMappingModelParserRuleCall_0());
		}
		this_EntityMappingModel_0=ruleEntityMappingModel
		{
			$current = $this_EntityMappingModel_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getDataTypeMappingModelAccess().getEnumMappingModelParserRuleCall_1());
		}
		this_EnumMappingModel_1=ruleEnumMappingModel
		{
			$current = $this_EnumMappingModel_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleInfoModelMappingModel
entryRuleInfoModelMappingModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getInfoModelMappingModelRule()); }
	iv_ruleInfoModelMappingModel=ruleInfoModelMappingModel
	{ $current=$iv_ruleInfoModelMappingModel.current; }
	EOF;

// Rule InfoModelMappingModel
ruleInfoModelMappingModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getInfoModelMappingModelAccess().getInfoModelMappingModelAction_0(),
					$current);
			}
		)
		otherlv_1='vortolang'
		{
			newLeafNode(otherlv_1, grammarAccess.getInfoModelMappingModelAccess().getVortolangKeyword_1());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getInfoModelMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0());
				}
				lv_lang_2_0=ruleVortoLangVersion
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getInfoModelMappingModelRule());
					}
					set(
						$current,
						"lang",
						lv_lang_2_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VortoLangVersion");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_3='namespace'
		{
			newLeafNode(otherlv_3, grammarAccess.getInfoModelMappingModelAccess().getNamespaceKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getInfoModelMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0());
				}
				lv_namespace_4_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getInfoModelMappingModelRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_4_0,
						"org.eclipse.vorto.editor.mapping.Mapping.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_5='version'
		{
			newLeafNode(otherlv_5, grammarAccess.getInfoModelMappingModelAccess().getVersionKeyword_5());
		}
		(
			(
				lv_version_6_0=RULE_VERSION
				{
					newLeafNode(lv_version_6_0, grammarAccess.getInfoModelMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getInfoModelMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_6_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VERSION");
				}
			)
		)
		(
			(
				{ 
				  getUnorderedGroupHelper().enter(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
				}
				(
					(
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 0);
					}
								({true}?=>(otherlv_8='displayname'
								{
									newLeafNode(otherlv_8, grammarAccess.getInfoModelMappingModelAccess().getDisplaynameKeyword_7_0_0());
								}
								(
									(
										lv_displayname_9_0=RULE_STRING
										{
											newLeafNode(lv_displayname_9_0, grammarAccess.getInfoModelMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getInfoModelMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"displayname",
												lv_displayname_9_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 1);
					}
								({true}?=>(otherlv_10='description'
								{
									newLeafNode(otherlv_10, grammarAccess.getInfoModelMappingModelAccess().getDescriptionKeyword_7_1_0());
								}
								(
									(
										lv_description_11_0=RULE_STRING
										{
											newLeafNode(lv_description_11_0, grammarAccess.getInfoModelMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getInfoModelMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"description",
												lv_description_11_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 2);
					}
								({true}?=>(otherlv_12='category'
								{
									newLeafNode(otherlv_12, grammarAccess.getInfoModelMappingModelAccess().getCategoryKeyword_7_2_0());
								}
								(
									(
										{
											newCompositeNode(grammarAccess.getInfoModelMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0());
										}
										lv_category_13_0=ruleCATEGORY
										{
											if ($current==null) {
												$current = createModelElementForParent(grammarAccess.getInfoModelMappingModelRule());
											}
											set(
												$current,
												"category",
												lv_category_13_0,
												"org.eclipse.vorto.editor.mapping.Mapping.CATEGORY");
											afterParserOrEnumRuleCall();
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)
					)*
				)
			)
				{ 
				  getUnorderedGroupHelper().leave(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
				}
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getInfoModelMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0());
				}
				lv_references_14_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getInfoModelMappingModelRule());
					}
					add(
						$current,
						"references",
						lv_references_14_0,
						"org.eclipse.vorto.editor.mapping.Mapping.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_15='infomodelmapping'
		{
			newLeafNode(otherlv_15, grammarAccess.getInfoModelMappingModelAccess().getInfomodelmappingKeyword_9());
		}
		(
			(
				lv_name_16_0=RULE_ID
				{
					newLeafNode(lv_name_16_0, grammarAccess.getInfoModelMappingModelAccess().getNameIDTerminalRuleCall_10_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getInfoModelMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_16_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_17='{'
		{
			newLeafNode(otherlv_17, grammarAccess.getInfoModelMappingModelAccess().getLeftCurlyBracketKeyword_11());
		}
		otherlv_18='targetplatform'
		{
			newLeafNode(otherlv_18, grammarAccess.getInfoModelMappingModelAccess().getTargetplatformKeyword_12());
		}
		(
			(
				lv_targetPlatform_19_0=RULE_ID
				{
					newLeafNode(lv_targetPlatform_19_0, grammarAccess.getInfoModelMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getInfoModelMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"targetPlatform",
						lv_targetPlatform_19_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getInfoModelMappingModelAccess().getRulesInfoModelMappingRuleParserRuleCall_14_0());
				}
				lv_rules_20_0=ruleInfoModelMappingRule
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getInfoModelMappingModelRule());
					}
					add(
						$current,
						"rules",
						lv_rules_20_0,
						"org.eclipse.vorto.editor.mapping.Mapping.InfoModelMappingRule");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_21='}'
		{
			newLeafNode(otherlv_21, grammarAccess.getInfoModelMappingModelAccess().getRightCurlyBracketKeyword_15());
		}
	)
;

// Entry rule entryRuleInfoModelMappingRule
entryRuleInfoModelMappingRule returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getInfoModelMappingRuleRule()); }
	iv_ruleInfoModelMappingRule=ruleInfoModelMappingRule
	{ $current=$iv_ruleInfoModelMappingRule.current; }
	EOF;

// Rule InfoModelMappingRule
ruleInfoModelMappingRule returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='from'
		{
			newLeafNode(otherlv_0, grammarAccess.getInfoModelMappingRuleAccess().getFromKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getInfoModelMappingRuleAccess().getSourcesInfomodelSourceParserRuleCall_1_0());
				}
				lv_sources_1_0=ruleInfomodelSource
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getInfoModelMappingRuleRule());
					}
					add(
						$current,
						"sources",
						lv_sources_1_0,
						"org.eclipse.vorto.editor.mapping.Mapping.InfomodelSource");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_2=','
			{
				newLeafNode(otherlv_2, grammarAccess.getInfoModelMappingRuleAccess().getCommaKeyword_2_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getInfoModelMappingRuleAccess().getSourcesInfomodelSourceParserRuleCall_2_1_0());
					}
					lv_sources_3_0=ruleInfomodelSource
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getInfoModelMappingRuleRule());
						}
						add(
							$current,
							"sources",
							lv_sources_3_0,
							"org.eclipse.vorto.editor.mapping.Mapping.InfomodelSource");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)*
		otherlv_4='to'
		{
			newLeafNode(otherlv_4, grammarAccess.getInfoModelMappingRuleAccess().getToKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getInfoModelMappingRuleAccess().getTargetTargetParserRuleCall_4_0());
				}
				lv_target_5_0=ruleTarget
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getInfoModelMappingRuleRule());
					}
					set(
						$current,
						"target",
						lv_target_5_0,
						"org.eclipse.vorto.editor.mapping.Mapping.Target");
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRuleInfomodelSource
entryRuleInfomodelSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getInfomodelSourceRule()); }
	iv_ruleInfomodelSource=ruleInfomodelSource
	{ $current=$iv_ruleInfomodelSource.current; }
	EOF;

// Rule InfomodelSource
ruleInfomodelSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getInfomodelSourceAccess().getInfoModelAttributeSourceParserRuleCall_0());
		}
		this_InfoModelAttributeSource_0=ruleInfoModelAttributeSource
		{
			$current = $this_InfoModelAttributeSource_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getInfomodelSourceAccess().getInfoModelPropertySourceParserRuleCall_1());
		}
		this_InfoModelPropertySource_1=ruleInfoModelPropertySource
		{
			$current = $this_InfoModelPropertySource_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleInfoModelPropertySource
entryRuleInfoModelPropertySource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getInfoModelPropertySourceRule()); }
	iv_ruleInfoModelPropertySource=ruleInfoModelPropertySource
	{ $current=$iv_ruleInfoModelPropertySource.current; }
	EOF;

// Rule InfoModelPropertySource
ruleInfoModelPropertySource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getInfoModelPropertySourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getInfoModelPropertySourceAccess().getModelInformationModelCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getInfoModelPropertySourceAccess().getFullStopKeyword_1());
		}
		otherlv_2='functionblocks'
		{
			newLeafNode(otherlv_2, grammarAccess.getInfoModelPropertySourceAccess().getFunctionblocksKeyword_2());
		}
		otherlv_3='.'
		{
			newLeafNode(otherlv_3, grammarAccess.getInfoModelPropertySourceAccess().getFullStopKeyword_3());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getInfoModelPropertySourceRule());
					}
				}
				otherlv_4=RULE_ID
				{
					newLeafNode(otherlv_4, grammarAccess.getInfoModelPropertySourceAccess().getPropertyFunctionblockPropertyCrossReference_4_0());
				}
			)
		)
	)
;

// Entry rule entryRuleInfoModelAttributeSource
entryRuleInfoModelAttributeSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getInfoModelAttributeSourceRule()); }
	iv_ruleInfoModelAttributeSource=ruleInfoModelAttributeSource
	{ $current=$iv_ruleInfoModelAttributeSource.current; }
	EOF;

// Rule InfoModelAttributeSource
ruleInfoModelAttributeSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getInfoModelAttributeSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getInfoModelAttributeSourceAccess().getModelInformationModelCrossReference_0_0());
				}
			)
		)
		(
			otherlv_1='.'
			{
				newLeafNode(otherlv_1, grammarAccess.getInfoModelAttributeSourceAccess().getFullStopKeyword_1_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getInfoModelAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0());
					}
					lv_attribute_2_0=ruleModelAttribute
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getInfoModelAttributeSourceRule());
						}
						set(
							$current,
							"attribute",
							lv_attribute_2_0,
							"org.eclipse.vorto.editor.mapping.Mapping.ModelAttribute");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
	)
;

// Entry rule entryRuleFunctionBlockMappingModel
entryRuleFunctionBlockMappingModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionBlockMappingModelRule()); }
	iv_ruleFunctionBlockMappingModel=ruleFunctionBlockMappingModel
	{ $current=$iv_ruleFunctionBlockMappingModel.current; }
	EOF;

// Rule FunctionBlockMappingModel
ruleFunctionBlockMappingModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getFunctionBlockMappingModelAccess().getFunctionBlockMappingModelAction_0(),
					$current);
			}
		)
		otherlv_1='vortolang'
		{
			newLeafNode(otherlv_1, grammarAccess.getFunctionBlockMappingModelAccess().getVortolangKeyword_1());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0());
				}
				lv_lang_2_0=ruleVortoLangVersion
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingModelRule());
					}
					set(
						$current,
						"lang",
						lv_lang_2_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VortoLangVersion");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_3='namespace'
		{
			newLeafNode(otherlv_3, grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0());
				}
				lv_namespace_4_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingModelRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_4_0,
						"org.eclipse.vorto.editor.mapping.Mapping.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_5='version'
		{
			newLeafNode(otherlv_5, grammarAccess.getFunctionBlockMappingModelAccess().getVersionKeyword_5());
		}
		(
			(
				lv_version_6_0=RULE_VERSION
				{
					newLeafNode(lv_version_6_0, grammarAccess.getFunctionBlockMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionBlockMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_6_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VERSION");
				}
			)
		)
		(
			(
				{ 
				  getUnorderedGroupHelper().enter(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
				}
				(
					(
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 0);
					}
								({true}?=>(otherlv_8='displayname'
								{
									newLeafNode(otherlv_8, grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameKeyword_7_0_0());
								}
								(
									(
										lv_displayname_9_0=RULE_STRING
										{
											newLeafNode(lv_displayname_9_0, grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getFunctionBlockMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"displayname",
												lv_displayname_9_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 1);
					}
								({true}?=>(otherlv_10='description'
								{
									newLeafNode(otherlv_10, grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionKeyword_7_1_0());
								}
								(
									(
										lv_description_11_0=RULE_STRING
										{
											newLeafNode(lv_description_11_0, grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getFunctionBlockMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"description",
												lv_description_11_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 2);
					}
								({true}?=>(otherlv_12='category'
								{
									newLeafNode(otherlv_12, grammarAccess.getFunctionBlockMappingModelAccess().getCategoryKeyword_7_2_0());
								}
								(
									(
										{
											newCompositeNode(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0());
										}
										lv_category_13_0=ruleCATEGORY
										{
											if ($current==null) {
												$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingModelRule());
											}
											set(
												$current,
												"category",
												lv_category_13_0,
												"org.eclipse.vorto.editor.mapping.Mapping.CATEGORY");
											afterParserOrEnumRuleCall();
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)
					)*
				)
			)
				{ 
				  getUnorderedGroupHelper().leave(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
				}
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0());
				}
				lv_references_14_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingModelRule());
					}
					add(
						$current,
						"references",
						lv_references_14_0,
						"org.eclipse.vorto.editor.mapping.Mapping.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_15='functionblockmapping'
		{
			newLeafNode(otherlv_15, grammarAccess.getFunctionBlockMappingModelAccess().getFunctionblockmappingKeyword_9());
		}
		(
			(
				lv_name_16_0=RULE_ID
				{
					newLeafNode(lv_name_16_0, grammarAccess.getFunctionBlockMappingModelAccess().getNameIDTerminalRuleCall_10_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionBlockMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_16_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_17='{'
		{
			newLeafNode(otherlv_17, grammarAccess.getFunctionBlockMappingModelAccess().getLeftCurlyBracketKeyword_11());
		}
		otherlv_18='targetplatform'
		{
			newLeafNode(otherlv_18, grammarAccess.getFunctionBlockMappingModelAccess().getTargetplatformKeyword_12());
		}
		(
			(
				lv_targetPlatform_19_0=RULE_ID
				{
					newLeafNode(lv_targetPlatform_19_0, grammarAccess.getFunctionBlockMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionBlockMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"targetPlatform",
						lv_targetPlatform_19_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockMappingModelAccess().getRulesFunctionBlockMappingRuleParserRuleCall_14_0());
				}
				lv_rules_20_0=ruleFunctionBlockMappingRule
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingModelRule());
					}
					add(
						$current,
						"rules",
						lv_rules_20_0,
						"org.eclipse.vorto.editor.mapping.Mapping.FunctionBlockMappingRule");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_21='}'
		{
			newLeafNode(otherlv_21, grammarAccess.getFunctionBlockMappingModelAccess().getRightCurlyBracketKeyword_15());
		}
	)
;

// Entry rule entryRuleModelReference
entryRuleModelReference returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getModelReferenceRule()); }
	iv_ruleModelReference=ruleModelReference
	{ $current=$iv_ruleModelReference.current; }
	EOF;

// Rule ModelReference
ruleModelReference returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='using'
		{
			newLeafNode(otherlv_0, grammarAccess.getModelReferenceAccess().getUsingKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0());
				}
				lv_importedNamespace_1_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getModelReferenceRule());
					}
					set(
						$current,
						"importedNamespace",
						lv_importedNamespace_1_0,
						"org.eclipse.vorto.editor.mapping.Mapping.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_2=';'
		{
			newLeafNode(otherlv_2, grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2());
		}
		(
			(
				lv_version_3_0=RULE_VERSION
				{
					newLeafNode(lv_version_3_0, grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getModelReferenceRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_3_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VERSION");
				}
			)
		)
	)
;

// Entry rule entryRuleFunctionBlockMappingRule
entryRuleFunctionBlockMappingRule returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionBlockMappingRuleRule()); }
	iv_ruleFunctionBlockMappingRule=ruleFunctionBlockMappingRule
	{ $current=$iv_ruleFunctionBlockMappingRule.current; }
	EOF;

// Rule FunctionBlockMappingRule
ruleFunctionBlockMappingRule returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='from'
		{
			newLeafNode(otherlv_0, grammarAccess.getFunctionBlockMappingRuleAccess().getFromKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesFunctionBlockSourceParserRuleCall_1_0());
				}
				lv_sources_1_0=ruleFunctionBlockSource
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingRuleRule());
					}
					add(
						$current,
						"sources",
						lv_sources_1_0,
						"org.eclipse.vorto.editor.mapping.Mapping.FunctionBlockSource");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_2=','
			{
				newLeafNode(otherlv_2, grammarAccess.getFunctionBlockMappingRuleAccess().getCommaKeyword_2_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesFunctionBlockSourceParserRuleCall_2_1_0());
					}
					lv_sources_3_0=ruleFunctionBlockSource
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingRuleRule());
						}
						add(
							$current,
							"sources",
							lv_sources_3_0,
							"org.eclipse.vorto.editor.mapping.Mapping.FunctionBlockSource");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)*
		otherlv_4='to'
		{
			newLeafNode(otherlv_4, grammarAccess.getFunctionBlockMappingRuleAccess().getToKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockMappingRuleAccess().getTargetTargetParserRuleCall_4_0());
				}
				lv_target_5_0=ruleTarget
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockMappingRuleRule());
					}
					set(
						$current,
						"target",
						lv_target_5_0,
						"org.eclipse.vorto.editor.mapping.Mapping.Target");
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRuleFunctionBlockSource
entryRuleFunctionBlockSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionBlockSourceRule()); }
	iv_ruleFunctionBlockSource=ruleFunctionBlockSource
	{ $current=$iv_ruleFunctionBlockSource.current; }
	EOF;

// Rule FunctionBlockSource
ruleFunctionBlockSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getFunctionBlockSourceAccess().getFunctionBlockAttributeSourceParserRuleCall_0());
		}
		this_FunctionBlockAttributeSource_0=ruleFunctionBlockAttributeSource
		{
			$current = $this_FunctionBlockAttributeSource_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getFunctionBlockSourceAccess().getFunctionBlockPropertySourceParserRuleCall_1());
		}
		this_FunctionBlockPropertySource_1=ruleFunctionBlockPropertySource
		{
			$current = $this_FunctionBlockPropertySource_1.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getFunctionBlockSourceAccess().getOperationSourceParserRuleCall_2());
		}
		this_OperationSource_2=ruleOperationSource
		{
			$current = $this_OperationSource_2.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getFunctionBlockSourceAccess().getEventSourceParserRuleCall_3());
		}
		this_EventSource_3=ruleEventSource
		{
			$current = $this_EventSource_3.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleFunctionBlockPropertySource
entryRuleFunctionBlockPropertySource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionBlockPropertySourceRule()); }
	iv_ruleFunctionBlockPropertySource=ruleFunctionBlockPropertySource
	{ $current=$iv_ruleFunctionBlockPropertySource.current; }
	EOF;

// Rule FunctionBlockPropertySource
ruleFunctionBlockPropertySource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getFunctionBlockPropertySourceAccess().getConfigurationSourceParserRuleCall_0());
		}
		this_ConfigurationSource_0=ruleConfigurationSource
		{
			$current = $this_ConfigurationSource_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getFunctionBlockPropertySourceAccess().getStatusSourceParserRuleCall_1());
		}
		this_StatusSource_1=ruleStatusSource
		{
			$current = $this_StatusSource_1.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getFunctionBlockPropertySourceAccess().getFaultSourceParserRuleCall_2());
		}
		this_FaultSource_2=ruleFaultSource
		{
			$current = $this_FaultSource_2.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleFunctionBlockAttributeSource
entryRuleFunctionBlockAttributeSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionBlockAttributeSourceRule()); }
	iv_ruleFunctionBlockAttributeSource=ruleFunctionBlockAttributeSource
	{ $current=$iv_ruleFunctionBlockAttributeSource.current; }
	EOF;

// Rule FunctionBlockAttributeSource
ruleFunctionBlockAttributeSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionBlockAttributeSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getFunctionBlockAttributeSourceAccess().getModelFunctionblockModelCrossReference_0_0());
				}
			)
		)
		(
			otherlv_1='.'
			{
				newLeafNode(otherlv_1, grammarAccess.getFunctionBlockAttributeSourceAccess().getFullStopKeyword_1_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getFunctionBlockAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0());
					}
					lv_attribute_2_0=ruleModelAttribute
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getFunctionBlockAttributeSourceRule());
						}
						set(
							$current,
							"attribute",
							lv_attribute_2_0,
							"org.eclipse.vorto.editor.mapping.Mapping.ModelAttribute");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
	)
;

// Entry rule entryRuleConfigurationSource
entryRuleConfigurationSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getConfigurationSourceRule()); }
	iv_ruleConfigurationSource=ruleConfigurationSource
	{ $current=$iv_ruleConfigurationSource.current; }
	EOF;

// Rule ConfigurationSource
ruleConfigurationSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getConfigurationSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getConfigurationSourceAccess().getModelFunctionblockModelCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getConfigurationSourceAccess().getFullStopKeyword_1());
		}
		otherlv_2='configuration'
		{
			newLeafNode(otherlv_2, grammarAccess.getConfigurationSourceAccess().getConfigurationKeyword_2());
		}
		otherlv_3='.'
		{
			newLeafNode(otherlv_3, grammarAccess.getConfigurationSourceAccess().getFullStopKeyword_3());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getConfigurationSourceRule());
					}
				}
				otherlv_4=RULE_ID
				{
					newLeafNode(otherlv_4, grammarAccess.getConfigurationSourceAccess().getPropertyPropertyCrossReference_4_0());
				}
			)
		)
	)
;

// Entry rule entryRuleStatusSource
entryRuleStatusSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getStatusSourceRule()); }
	iv_ruleStatusSource=ruleStatusSource
	{ $current=$iv_ruleStatusSource.current; }
	EOF;

// Rule StatusSource
ruleStatusSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getStatusSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getStatusSourceAccess().getModelFunctionblockModelCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getStatusSourceAccess().getFullStopKeyword_1());
		}
		otherlv_2='status'
		{
			newLeafNode(otherlv_2, grammarAccess.getStatusSourceAccess().getStatusKeyword_2());
		}
		otherlv_3='.'
		{
			newLeafNode(otherlv_3, grammarAccess.getStatusSourceAccess().getFullStopKeyword_3());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getStatusSourceRule());
					}
				}
				otherlv_4=RULE_ID
				{
					newLeafNode(otherlv_4, grammarAccess.getStatusSourceAccess().getPropertyPropertyCrossReference_4_0());
				}
			)
		)
	)
;

// Entry rule entryRuleFaultSource
entryRuleFaultSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFaultSourceRule()); }
	iv_ruleFaultSource=ruleFaultSource
	{ $current=$iv_ruleFaultSource.current; }
	EOF;

// Rule FaultSource
ruleFaultSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFaultSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getFaultSourceAccess().getModelFunctionblockModelCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getFaultSourceAccess().getFullStopKeyword_1());
		}
		otherlv_2='fault'
		{
			newLeafNode(otherlv_2, grammarAccess.getFaultSourceAccess().getFaultKeyword_2());
		}
		otherlv_3='.'
		{
			newLeafNode(otherlv_3, grammarAccess.getFaultSourceAccess().getFullStopKeyword_3());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFaultSourceRule());
					}
				}
				otherlv_4=RULE_ID
				{
					newLeafNode(otherlv_4, grammarAccess.getFaultSourceAccess().getPropertyPropertyCrossReference_4_0());
				}
			)
		)
	)
;

// Entry rule entryRuleOperationSource
entryRuleOperationSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getOperationSourceRule()); }
	iv_ruleOperationSource=ruleOperationSource
	{ $current=$iv_ruleOperationSource.current; }
	EOF;

// Rule OperationSource
ruleOperationSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getOperationSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getOperationSourceAccess().getModelFunctionblockModelCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getOperationSourceAccess().getFullStopKeyword_1());
		}
		otherlv_2='operation'
		{
			newLeafNode(otherlv_2, grammarAccess.getOperationSourceAccess().getOperationKeyword_2());
		}
		otherlv_3='.'
		{
			newLeafNode(otherlv_3, grammarAccess.getOperationSourceAccess().getFullStopKeyword_3());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getOperationSourceRule());
					}
				}
				otherlv_4=RULE_ID
				{
					newLeafNode(otherlv_4, grammarAccess.getOperationSourceAccess().getOperationOperationCrossReference_4_0());
				}
			)
		)
		(
			otherlv_5='.'
			{
				newLeafNode(otherlv_5, grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_0());
			}
			otherlv_6='params'
			{
				newLeafNode(otherlv_6, grammarAccess.getOperationSourceAccess().getParamsKeyword_5_1());
			}
			(
				otherlv_7='.'
				{
					newLeafNode(otherlv_7, grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_2());
				}
			)+
			(
				(
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getOperationSourceRule());
						}
					}
					otherlv_8=RULE_ID
					{
						newLeafNode(otherlv_8, grammarAccess.getOperationSourceAccess().getParamParamCrossReference_5_3_0());
					}
				)
			)
		)?
	)
;

// Entry rule entryRuleEventSource
entryRuleEventSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEventSourceRule()); }
	iv_ruleEventSource=ruleEventSource
	{ $current=$iv_ruleEventSource.current; }
	EOF;

// Rule EventSource
ruleEventSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEventSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getEventSourceAccess().getModelFunctionblockModelCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getEventSourceAccess().getFullStopKeyword_1());
		}
		otherlv_2='event'
		{
			newLeafNode(otherlv_2, grammarAccess.getEventSourceAccess().getEventKeyword_2());
		}
		otherlv_3='.'
		{
			newLeafNode(otherlv_3, grammarAccess.getEventSourceAccess().getFullStopKeyword_3());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEventSourceRule());
					}
				}
				otherlv_4=RULE_ID
				{
					newLeafNode(otherlv_4, grammarAccess.getEventSourceAccess().getEventEventCrossReference_4_0());
				}
			)
		)
		(
			otherlv_5='.'
			{
				newLeafNode(otherlv_5, grammarAccess.getEventSourceAccess().getFullStopKeyword_5_0());
			}
			(
				(
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getEventSourceRule());
						}
					}
					otherlv_6=RULE_ID
					{
						newLeafNode(otherlv_6, grammarAccess.getEventSourceAccess().getEventPropertyPropertyCrossReference_5_1_0());
					}
				)
			)
		)?
	)
;

// Entry rule entryRuleEntityMappingModel
entryRuleEntityMappingModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEntityMappingModelRule()); }
	iv_ruleEntityMappingModel=ruleEntityMappingModel
	{ $current=$iv_ruleEntityMappingModel.current; }
	EOF;

// Rule EntityMappingModel
ruleEntityMappingModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getEntityMappingModelAccess().getEntityMappingModelAction_0(),
					$current);
			}
		)
		otherlv_1='vortolang'
		{
			newLeafNode(otherlv_1, grammarAccess.getEntityMappingModelAccess().getVortolangKeyword_1());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0());
				}
				lv_lang_2_0=ruleVortoLangVersion
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityMappingModelRule());
					}
					set(
						$current,
						"lang",
						lv_lang_2_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VortoLangVersion");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_3='namespace'
		{
			newLeafNode(otherlv_3, grammarAccess.getEntityMappingModelAccess().getNamespaceKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0());
				}
				lv_namespace_4_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityMappingModelRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_4_0,
						"org.eclipse.vorto.editor.mapping.Mapping.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_5='version'
		{
			newLeafNode(otherlv_5, grammarAccess.getEntityMappingModelAccess().getVersionKeyword_5());
		}
		(
			(
				lv_version_6_0=RULE_VERSION
				{
					newLeafNode(lv_version_6_0, grammarAccess.getEntityMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_6_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VERSION");
				}
			)
		)
		(
			(
				{ 
				  getUnorderedGroupHelper().enter(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
				}
				(
					(
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 0);
					}
								({true}?=>(otherlv_8='displayname'
								{
									newLeafNode(otherlv_8, grammarAccess.getEntityMappingModelAccess().getDisplaynameKeyword_7_0_0());
								}
								(
									(
										lv_displayname_9_0=RULE_STRING
										{
											newLeafNode(lv_displayname_9_0, grammarAccess.getEntityMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getEntityMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"displayname",
												lv_displayname_9_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 1);
					}
								({true}?=>(otherlv_10='description'
								{
									newLeafNode(otherlv_10, grammarAccess.getEntityMappingModelAccess().getDescriptionKeyword_7_1_0());
								}
								(
									(
										lv_description_11_0=RULE_STRING
										{
											newLeafNode(lv_description_11_0, grammarAccess.getEntityMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getEntityMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"description",
												lv_description_11_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 2);
					}
								({true}?=>(otherlv_12='category'
								{
									newLeafNode(otherlv_12, grammarAccess.getEntityMappingModelAccess().getCategoryKeyword_7_2_0());
								}
								(
									(
										{
											newCompositeNode(grammarAccess.getEntityMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0());
										}
										lv_category_13_0=ruleCATEGORY
										{
											if ($current==null) {
												$current = createModelElementForParent(grammarAccess.getEntityMappingModelRule());
											}
											set(
												$current,
												"category",
												lv_category_13_0,
												"org.eclipse.vorto.editor.mapping.Mapping.CATEGORY");
											afterParserOrEnumRuleCall();
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)
					)*
				)
			)
				{ 
				  getUnorderedGroupHelper().leave(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
				}
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0());
				}
				lv_references_14_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityMappingModelRule());
					}
					add(
						$current,
						"references",
						lv_references_14_0,
						"org.eclipse.vorto.editor.mapping.Mapping.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_15='entitymapping'
		{
			newLeafNode(otherlv_15, grammarAccess.getEntityMappingModelAccess().getEntitymappingKeyword_9());
		}
		(
			(
				lv_name_16_0=RULE_ID
				{
					newLeafNode(lv_name_16_0, grammarAccess.getEntityMappingModelAccess().getNameIDTerminalRuleCall_10_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_16_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_17='{'
		{
			newLeafNode(otherlv_17, grammarAccess.getEntityMappingModelAccess().getLeftCurlyBracketKeyword_11());
		}
		otherlv_18='targetplatform'
		{
			newLeafNode(otherlv_18, grammarAccess.getEntityMappingModelAccess().getTargetplatformKeyword_12());
		}
		(
			(
				lv_targetPlatform_19_0=RULE_ID
				{
					newLeafNode(lv_targetPlatform_19_0, grammarAccess.getEntityMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"targetPlatform",
						lv_targetPlatform_19_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityMappingModelAccess().getRulesEntityMappingRuleParserRuleCall_14_0());
				}
				lv_rules_20_0=ruleEntityMappingRule
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityMappingModelRule());
					}
					add(
						$current,
						"rules",
						lv_rules_20_0,
						"org.eclipse.vorto.editor.mapping.Mapping.EntityMappingRule");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_21='}'
		{
			newLeafNode(otherlv_21, grammarAccess.getEntityMappingModelAccess().getRightCurlyBracketKeyword_15());
		}
	)
;

// Entry rule entryRuleEntityMappingRule
entryRuleEntityMappingRule returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEntityMappingRuleRule()); }
	iv_ruleEntityMappingRule=ruleEntityMappingRule
	{ $current=$iv_ruleEntityMappingRule.current; }
	EOF;

// Rule EntityMappingRule
ruleEntityMappingRule returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='from'
		{
			newLeafNode(otherlv_0, grammarAccess.getEntityMappingRuleAccess().getFromKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityMappingRuleAccess().getSourcesEntitySourceParserRuleCall_1_0());
				}
				lv_sources_1_0=ruleEntitySource
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityMappingRuleRule());
					}
					add(
						$current,
						"sources",
						lv_sources_1_0,
						"org.eclipse.vorto.editor.mapping.Mapping.EntitySource");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_2=','
			{
				newLeafNode(otherlv_2, grammarAccess.getEntityMappingRuleAccess().getCommaKeyword_2_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getEntityMappingRuleAccess().getSourcesEntitySourceParserRuleCall_2_1_0());
					}
					lv_sources_3_0=ruleEntitySource
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEntityMappingRuleRule());
						}
						add(
							$current,
							"sources",
							lv_sources_3_0,
							"org.eclipse.vorto.editor.mapping.Mapping.EntitySource");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)*
		otherlv_4='to'
		{
			newLeafNode(otherlv_4, grammarAccess.getEntityMappingRuleAccess().getToKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityMappingRuleAccess().getTargetTargetParserRuleCall_4_0());
				}
				lv_target_5_0=ruleTarget
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityMappingRuleRule());
					}
					set(
						$current,
						"target",
						lv_target_5_0,
						"org.eclipse.vorto.editor.mapping.Mapping.Target");
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRuleEntitySource
entryRuleEntitySource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEntitySourceRule()); }
	iv_ruleEntitySource=ruleEntitySource
	{ $current=$iv_ruleEntitySource.current; }
	EOF;

// Rule EntitySource
ruleEntitySource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getEntitySourceAccess().getEntityAttributeSourceParserRuleCall_0());
		}
		this_EntityAttributeSource_0=ruleEntityAttributeSource
		{
			$current = $this_EntityAttributeSource_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getEntitySourceAccess().getEntityPropertySourceParserRuleCall_1());
		}
		this_EntityPropertySource_1=ruleEntityPropertySource
		{
			$current = $this_EntityPropertySource_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleEntityPropertySource
entryRuleEntityPropertySource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEntityPropertySourceRule()); }
	iv_ruleEntityPropertySource=ruleEntityPropertySource
	{ $current=$iv_ruleEntityPropertySource.current; }
	EOF;

// Rule EntityPropertySource
ruleEntityPropertySource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityPropertySourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getEntityPropertySourceAccess().getModelEntityCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getEntityPropertySourceAccess().getFullStopKeyword_1());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityPropertySourceRule());
					}
				}
				otherlv_2=RULE_ID
				{
					newLeafNode(otherlv_2, grammarAccess.getEntityPropertySourceAccess().getPropertyPropertyCrossReference_2_0());
				}
			)
		)
	)
;

// Entry rule entryRuleEntityAttributeSource
entryRuleEntityAttributeSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEntityAttributeSourceRule()); }
	iv_ruleEntityAttributeSource=ruleEntityAttributeSource
	{ $current=$iv_ruleEntityAttributeSource.current; }
	EOF;

// Rule EntityAttributeSource
ruleEntityAttributeSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityAttributeSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getEntityAttributeSourceAccess().getModelEntityCrossReference_0_0());
				}
			)
		)
		(
			otherlv_1='.'
			{
				newLeafNode(otherlv_1, grammarAccess.getEntityAttributeSourceAccess().getFullStopKeyword_1_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getEntityAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0());
					}
					lv_attribute_2_0=ruleModelAttribute
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEntityAttributeSourceRule());
						}
						set(
							$current,
							"attribute",
							lv_attribute_2_0,
							"org.eclipse.vorto.editor.mapping.Mapping.ModelAttribute");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
	)
;

// Entry rule entryRuleEnumMappingModel
entryRuleEnumMappingModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumMappingModelRule()); }
	iv_ruleEnumMappingModel=ruleEnumMappingModel
	{ $current=$iv_ruleEnumMappingModel.current; }
	EOF;

// Rule EnumMappingModel
ruleEnumMappingModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getEnumMappingModelAccess().getEnumMappingModelAction_0(),
					$current);
			}
		)
		otherlv_1='vortolang'
		{
			newLeafNode(otherlv_1, grammarAccess.getEnumMappingModelAccess().getVortolangKeyword_1());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0());
				}
				lv_lang_2_0=ruleVortoLangVersion
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumMappingModelRule());
					}
					set(
						$current,
						"lang",
						lv_lang_2_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VortoLangVersion");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_3='namespace'
		{
			newLeafNode(otherlv_3, grammarAccess.getEnumMappingModelAccess().getNamespaceKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0());
				}
				lv_namespace_4_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumMappingModelRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_4_0,
						"org.eclipse.vorto.editor.mapping.Mapping.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_5='version'
		{
			newLeafNode(otherlv_5, grammarAccess.getEnumMappingModelAccess().getVersionKeyword_5());
		}
		(
			(
				lv_version_6_0=RULE_VERSION
				{
					newLeafNode(lv_version_6_0, grammarAccess.getEnumMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_6_0,
						"org.eclipse.vorto.editor.mapping.Mapping.VERSION");
				}
			)
		)
		(
			(
				{ 
				  getUnorderedGroupHelper().enter(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
				}
				(
					(
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 0);
					}
								({true}?=>(otherlv_8='displayname'
								{
									newLeafNode(otherlv_8, grammarAccess.getEnumMappingModelAccess().getDisplaynameKeyword_7_0_0());
								}
								(
									(
										lv_displayname_9_0=RULE_STRING
										{
											newLeafNode(lv_displayname_9_0, grammarAccess.getEnumMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getEnumMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"displayname",
												lv_displayname_9_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 1);
					}
								({true}?=>(otherlv_10='description'
								{
									newLeafNode(otherlv_10, grammarAccess.getEnumMappingModelAccess().getDescriptionKeyword_7_1_0());
								}
								(
									(
										lv_description_11_0=RULE_STRING
										{
											newLeafNode(lv_description_11_0, grammarAccess.getEnumMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0());
										}
										{
											if ($current==null) {
												$current = createModelElement(grammarAccess.getEnumMappingModelRule());
											}
											setWithLastConsumed(
												$current,
												"description",
												lv_description_11_0,
												"org.eclipse.xtext.common.Terminals.STRING");
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)|
			(
				{getUnorderedGroupHelper().canSelect(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
					{
						getUnorderedGroupHelper().select(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 2);
					}
								({true}?=>(otherlv_12='category'
								{
									newLeafNode(otherlv_12, grammarAccess.getEnumMappingModelAccess().getCategoryKeyword_7_2_0());
								}
								(
									(
										{
											newCompositeNode(grammarAccess.getEnumMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0());
										}
										lv_category_13_0=ruleCATEGORY
										{
											if ($current==null) {
												$current = createModelElementForParent(grammarAccess.getEnumMappingModelRule());
											}
											set(
												$current,
												"category",
												lv_category_13_0,
												"org.eclipse.vorto.editor.mapping.Mapping.CATEGORY");
											afterParserOrEnumRuleCall();
										}
									)
								)
								))
					{ 
						getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
					}
				)
			)
					)*
				)
			)
				{ 
				  getUnorderedGroupHelper().leave(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
				}
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0());
				}
				lv_references_14_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumMappingModelRule());
					}
					add(
						$current,
						"references",
						lv_references_14_0,
						"org.eclipse.vorto.editor.mapping.Mapping.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_15='enummapping'
		{
			newLeafNode(otherlv_15, grammarAccess.getEnumMappingModelAccess().getEnummappingKeyword_9());
		}
		(
			(
				lv_name_16_0=RULE_ID
				{
					newLeafNode(lv_name_16_0, grammarAccess.getEnumMappingModelAccess().getNameIDTerminalRuleCall_10_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_16_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_17='{'
		{
			newLeafNode(otherlv_17, grammarAccess.getEnumMappingModelAccess().getLeftCurlyBracketKeyword_11());
		}
		otherlv_18='targetplatform'
		{
			newLeafNode(otherlv_18, grammarAccess.getEnumMappingModelAccess().getTargetplatformKeyword_12());
		}
		(
			(
				lv_targetPlatform_19_0=RULE_ID
				{
					newLeafNode(lv_targetPlatform_19_0, grammarAccess.getEnumMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumMappingModelRule());
					}
					setWithLastConsumed(
						$current,
						"targetPlatform",
						lv_targetPlatform_19_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumMappingModelAccess().getRulesEnumMappingRuleParserRuleCall_14_0());
				}
				lv_rules_20_0=ruleEnumMappingRule
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumMappingModelRule());
					}
					add(
						$current,
						"rules",
						lv_rules_20_0,
						"org.eclipse.vorto.editor.mapping.Mapping.EnumMappingRule");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_21='}'
		{
			newLeafNode(otherlv_21, grammarAccess.getEnumMappingModelAccess().getRightCurlyBracketKeyword_15());
		}
	)
;

// Entry rule entryRuleEnumMappingRule
entryRuleEnumMappingRule returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumMappingRuleRule()); }
	iv_ruleEnumMappingRule=ruleEnumMappingRule
	{ $current=$iv_ruleEnumMappingRule.current; }
	EOF;

// Rule EnumMappingRule
ruleEnumMappingRule returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='from'
		{
			newLeafNode(otherlv_0, grammarAccess.getEnumMappingRuleAccess().getFromKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumMappingRuleAccess().getSourcesEnumSourceParserRuleCall_1_0());
				}
				lv_sources_1_0=ruleEnumSource
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumMappingRuleRule());
					}
					add(
						$current,
						"sources",
						lv_sources_1_0,
						"org.eclipse.vorto.editor.mapping.Mapping.EnumSource");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_2=','
			{
				newLeafNode(otherlv_2, grammarAccess.getEnumMappingRuleAccess().getCommaKeyword_2_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getEnumMappingRuleAccess().getSourcesEnumSourceParserRuleCall_2_1_0());
					}
					lv_sources_3_0=ruleEnumSource
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEnumMappingRuleRule());
						}
						add(
							$current,
							"sources",
							lv_sources_3_0,
							"org.eclipse.vorto.editor.mapping.Mapping.EnumSource");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)*
		otherlv_4='to'
		{
			newLeafNode(otherlv_4, grammarAccess.getEnumMappingRuleAccess().getToKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumMappingRuleAccess().getTargetTargetParserRuleCall_4_0());
				}
				lv_target_5_0=ruleTarget
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumMappingRuleRule());
					}
					set(
						$current,
						"target",
						lv_target_5_0,
						"org.eclipse.vorto.editor.mapping.Mapping.Target");
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRuleEnumSource
entryRuleEnumSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumSourceRule()); }
	iv_ruleEnumSource=ruleEnumSource
	{ $current=$iv_ruleEnumSource.current; }
	EOF;

// Rule EnumSource
ruleEnumSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getEnumSourceAccess().getEnumAttributeSourceParserRuleCall_0());
		}
		this_EnumAttributeSource_0=ruleEnumAttributeSource
		{
			$current = $this_EnumAttributeSource_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getEnumSourceAccess().getEnumPropertySourceParserRuleCall_1());
		}
		this_EnumPropertySource_1=ruleEnumPropertySource
		{
			$current = $this_EnumPropertySource_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleEnumPropertySource
entryRuleEnumPropertySource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumPropertySourceRule()); }
	iv_ruleEnumPropertySource=ruleEnumPropertySource
	{ $current=$iv_ruleEnumPropertySource.current; }
	EOF;

// Rule EnumPropertySource
ruleEnumPropertySource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumPropertySourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getEnumPropertySourceAccess().getModelEnumCrossReference_0_0());
				}
			)
		)
		otherlv_1='.'
		{
			newLeafNode(otherlv_1, grammarAccess.getEnumPropertySourceAccess().getFullStopKeyword_1());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumPropertySourceRule());
					}
				}
				otherlv_2=RULE_ID
				{
					newLeafNode(otherlv_2, grammarAccess.getEnumPropertySourceAccess().getPropertyEnumLiteralCrossReference_2_0());
				}
			)
		)
	)
;

// Entry rule entryRuleEnumAttributeSource
entryRuleEnumAttributeSource returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumAttributeSourceRule()); }
	iv_ruleEnumAttributeSource=ruleEnumAttributeSource
	{ $current=$iv_ruleEnumAttributeSource.current; }
	EOF;

// Rule EnumAttributeSource
ruleEnumAttributeSource returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumAttributeSourceRule());
					}
				}
				otherlv_0=RULE_ID
				{
					newLeafNode(otherlv_0, grammarAccess.getEnumAttributeSourceAccess().getModelEnumCrossReference_0_0());
				}
			)
		)
		(
			otherlv_1='.'
			{
				newLeafNode(otherlv_1, grammarAccess.getEnumAttributeSourceAccess().getFullStopKeyword_1_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getEnumAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0());
					}
					lv_attribute_2_0=ruleModelAttribute
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEnumAttributeSourceRule());
						}
						set(
							$current,
							"attribute",
							lv_attribute_2_0,
							"org.eclipse.vorto.editor.mapping.Mapping.ModelAttribute");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
	)
;

// Entry rule entryRuleTarget
entryRuleTarget returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getTargetRule()); }
	iv_ruleTarget=ruleTarget
	{ $current=$iv_ruleTarget.current; }
	EOF;

// Rule Target
ruleTarget returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getTargetAccess().getStereoTypeTargetParserRuleCall_0());
		}
		this_StereoTypeTarget_0=ruleStereoTypeTarget
		{
			$current = $this_StereoTypeTarget_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getTargetAccess().getReferenceTargetParserRuleCall_1());
		}
		this_ReferenceTarget_1=ruleReferenceTarget
		{
			$current = $this_ReferenceTarget_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleReferenceTarget
entryRuleReferenceTarget returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getReferenceTargetRule()); }
	iv_ruleReferenceTarget=ruleReferenceTarget
	{ $current=$iv_ruleReferenceTarget.current; }
	EOF;

// Rule ReferenceTarget
ruleReferenceTarget returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='reference'
		{
			newLeafNode(otherlv_0, grammarAccess.getReferenceTargetAccess().getReferenceKeyword_0());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getReferenceTargetRule());
					}
				}
				otherlv_1=RULE_ID
				{
					newLeafNode(otherlv_1, grammarAccess.getReferenceTargetAccess().getMappingModelMappingModelCrossReference_1_0());
				}
			)
		)
	)
;

// Entry rule entryRuleStereoTypeTarget
entryRuleStereoTypeTarget returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getStereoTypeTargetRule()); }
	iv_ruleStereoTypeTarget=ruleStereoTypeTarget
	{ $current=$iv_ruleStereoTypeTarget.current; }
	EOF;

// Rule StereoTypeTarget
ruleStereoTypeTarget returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_name_0_0=RULE_ID
				{
					newLeafNode(lv_name_0_0, grammarAccess.getStereoTypeTargetAccess().getNameIDTerminalRuleCall_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getStereoTypeTargetRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_0_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			otherlv_1='with'
			{
				newLeafNode(otherlv_1, grammarAccess.getStereoTypeTargetAccess().getWithKeyword_1_0());
			}
			otherlv_2='{'
			{
				newLeafNode(otherlv_2, grammarAccess.getStereoTypeTargetAccess().getLeftCurlyBracketKeyword_1_1());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getStereoTypeTargetAccess().getAttributesAttributeParserRuleCall_1_2_0());
					}
					lv_attributes_3_0=ruleAttribute
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getStereoTypeTargetRule());
						}
						add(
							$current,
							"attributes",
							lv_attributes_3_0,
							"org.eclipse.vorto.editor.mapping.Mapping.Attribute");
						afterParserOrEnumRuleCall();
					}
				)
			)
			(
				otherlv_4=','
				{
					newLeafNode(otherlv_4, grammarAccess.getStereoTypeTargetAccess().getCommaKeyword_1_3_0());
				}
				(
					(
						{
							newCompositeNode(grammarAccess.getStereoTypeTargetAccess().getAttributesAttributeParserRuleCall_1_3_1_0());
						}
						lv_attributes_5_0=ruleAttribute
						{
							if ($current==null) {
								$current = createModelElementForParent(grammarAccess.getStereoTypeTargetRule());
							}
							add(
								$current,
								"attributes",
								lv_attributes_5_0,
								"org.eclipse.vorto.editor.mapping.Mapping.Attribute");
							afterParserOrEnumRuleCall();
						}
					)
				)
			)*
			otherlv_6='}'
			{
				newLeafNode(otherlv_6, grammarAccess.getStereoTypeTargetAccess().getRightCurlyBracketKeyword_1_4());
			}
		)?
	)
;

// Entry rule entryRuleAttribute
entryRuleAttribute returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getAttributeRule()); }
	iv_ruleAttribute=ruleAttribute
	{ $current=$iv_ruleAttribute.current; }
	EOF;

// Rule Attribute
ruleAttribute returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_name_0_0=RULE_ID
				{
					newLeafNode(lv_name_0_0, grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getAttributeRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_0_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_1=':'
		{
			newLeafNode(otherlv_1, grammarAccess.getAttributeAccess().getColonKeyword_1());
		}
		(
			(
				lv_value_2_0=RULE_STRING
				{
					newLeafNode(lv_value_2_0, grammarAccess.getAttributeAccess().getValueSTRINGTerminalRuleCall_2_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getAttributeRule());
					}
					setWithLastConsumed(
						$current,
						"value",
						lv_value_2_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)
	)
;

// Entry rule entryRuleQualifiedName
entryRuleQualifiedName returns [String current=null]:
	{ newCompositeNode(grammarAccess.getQualifiedNameRule()); }
	iv_ruleQualifiedName=ruleQualifiedName
	{ $current=$iv_ruleQualifiedName.current.getText(); }
	EOF;

// Rule QualifiedName
ruleQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		this_ID_0=RULE_ID
		{
			$current.merge(this_ID_0);
		}
		{
			newLeafNode(this_ID_0, grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0());
		}
		(
			kw='.'
			{
				$current.merge(kw);
				newLeafNode(kw, grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0());
			}
			this_ID_2=RULE_ID
			{
				$current.merge(this_ID_2);
			}
			{
				newLeafNode(this_ID_2, grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1());
			}
		)*
	)
;

// Entry rule entryRuleCATEGORY
entryRuleCATEGORY returns [String current=null]:
	{ newCompositeNode(grammarAccess.getCATEGORYRule()); }
	iv_ruleCATEGORY=ruleCATEGORY
	{ $current=$iv_ruleCATEGORY.current.getText(); }
	EOF;

// Rule CATEGORY
ruleCATEGORY returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		this_ID_0=RULE_ID
		{
			$current.merge(this_ID_0);
		}
		{
			newLeafNode(this_ID_0, grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0());
		}
		(
			kw='/'
			{
				$current.merge(kw);
				newLeafNode(kw, grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0());
			}
			this_ID_2=RULE_ID
			{
				$current.merge(this_ID_2);
			}
			{
				newLeafNode(this_ID_2, grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1());
			}
		)*
	)
;

// Rule VortoLangVersion
ruleVortoLangVersion returns [Enumerator current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		enumLiteral_0='1.0'
		{
			$current = grammarAccess.getVortoLangVersionAccess().getVersion1EnumLiteralDeclaration().getEnumLiteral().getInstance();
			newLeafNode(enumLiteral_0, grammarAccess.getVortoLangVersionAccess().getVersion1EnumLiteralDeclaration());
		}
	)
;

// Rule ModelAttribute
ruleModelAttribute returns [Enumerator current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			enumLiteral_0='name'
			{
				$current = grammarAccess.getModelAttributeAccess().getNameEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_0, grammarAccess.getModelAttributeAccess().getNameEnumLiteralDeclaration_0());
			}
		)
		    |
		(
			enumLiteral_1='namespace'
			{
				$current = grammarAccess.getModelAttributeAccess().getNamespaceEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_1, grammarAccess.getModelAttributeAccess().getNamespaceEnumLiteralDeclaration_1());
			}
		)
		    |
		(
			enumLiteral_2='version'
			{
				$current = grammarAccess.getModelAttributeAccess().getVersionEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_2, grammarAccess.getModelAttributeAccess().getVersionEnumLiteralDeclaration_2());
			}
		)
		    |
		(
			enumLiteral_3='displayname'
			{
				$current = grammarAccess.getModelAttributeAccess().getDisplaynameEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_3, grammarAccess.getModelAttributeAccess().getDisplaynameEnumLiteralDeclaration_3());
			}
		)
		    |
		(
			enumLiteral_4='category'
			{
				$current = grammarAccess.getModelAttributeAccess().getCategoryEnumLiteralDeclaration_4().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_4, grammarAccess.getModelAttributeAccess().getCategoryEnumLiteralDeclaration_4());
			}
		)
		    |
		(
			enumLiteral_5='description'
			{
				$current = grammarAccess.getModelAttributeAccess().getDescriptionEnumLiteralDeclaration_5().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_5, grammarAccess.getModelAttributeAccess().getDescriptionEnumLiteralDeclaration_5());
			}
		)
	)
;

RULE_VERSION : ('0'..'9')* '.' ('0'..'9')* '.' ('0'..'9')* ('-' RULE_ID)?;

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
